# mypy-boto3-sms-voice

[![PyPI - mypy-boto3-sms-voice](https://img.shields.io/pypi/v/mypy-boto3-sms-voice.svg?color=blue)](https://pypi.org/project/mypy-boto3-sms-voice)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-sms-voice.svg?color=blue)](https://pypi.org/project/mypy-boto3-sms-voice)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dw/mypy-boto3-sms-voice?color=blue)](https://pypistats.org/packages/mypy-boto3-sms-voice)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.SMSVoice 1.17.60](https://boto3.amazonaws.com/v1/documentation/api/1.17.60/reference/services/sms-voice.html#SMSVoice) service
compatible with
[VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright)
and other tools.

Generated by [mypy-boto3-buider 4.7.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-sms-voice](#mypy-boto3-sms-voice)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Waiters annotations](#waiters-annotations)
    - [Service Resource annotations](#service-resource-annotations)
    - [Other resources annotations](#other-resources-annotations)
    - [Collections annotations](#collections-annotations)
    - [Typed dictionations](#typed-dictionations)

## How to install

Install `boto3-stubs` for `SMSVoice` service.

```bash
python -m pip install boto3-stubs[sms-voice]
```

## Usage

### VSCode

- Install [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[sms-voice]` in your environment: `python -m pip install 'boto3-stubs[sms-voice]'`

Both type checking and auto-complete should work for `SMSVoice` service.
No explicit type annotations required, write your `boto3` code as usual.

### PyCharm

- Install `boto-stubs[sms-voice]` in your environment: `python -m pip install 'boto3-stubs[sms-voice]'`

Both type checking and auto-complete should work for `SMSVoice` service.
No explicit type annotations required, write your `boto3` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed `boto3-stubs` submodules.

### Other IDEs

Not tested, but as long as your IDE support `mypy` or `pyright`, everything should work.

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[sms-voice]` in your environment: `python -m pip install 'boto3-stubs[sms-voice]'`
- Run `mypy` as usual

Type checking should work for `SMSVoice` service.
No explicit type annotations required, write your `boto3` code as usual.

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[sms-voice]` in your environment: `python -m pip install 'boto3-stubs[sms-voice]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `SMSVoice` service.
No explicit type annotations required, write your `boto3` code as usual.

## Explicit type annotations

### Client annotations

`SMSVoiceClient` provides annotations for `boto3.client("sms-voice")`.

```python
import boto3

from mypy_boto3_sms_voice import SMSVoiceClient

client: SMSVoiceClient = boto3.client("sms-voice")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: SMSVoiceClient = session.client("sms-voice")
```








### Literals

`mypy_boto3_sms_voice.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from mypy_boto3_sms_voice.literals import (
    EventType,
)

def check_value(value: EventType) -> bool:
    ...
```



### Typed dictionaries

`mypy_boto3_sms_voice.type_defs` module contains structures and shapes assembled
to typed dictionaries for additional type checking.

```python
from mypy_boto3_sms_voice.type_defs import (
    CallInstructionsMessageTypeTypeDef,
    CloudWatchLogsDestinationTypeDef,
    EventDestinationTypeDef,
    KinesisFirehoseDestinationTypeDef,
    PlainTextMessageTypeTypeDef,
    SSMLMessageTypeTypeDef,
    SnsDestinationTypeDef,
    EventDestinationDefinitionTypeDef,
    GetConfigurationSetEventDestinationsResponseTypeDef,
    ListConfigurationSetsResponseTypeDef,
    SendVoiceMessageResponseTypeDef,
    VoiceMessageContentTypeDef,
)

def get_structure() -> CallInstructionsMessageTypeTypeDef:
    return {
      ...
    }
```
